/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     BEGINTITLE = 258,
     ENDTITLE = 259,
     VBOX = 260,
     EVBOX = 261,
     HBOX = 262,
     EHBOX = 263,
     FRAME = 264,
     EFRAME = 265,
     ENTRY = 266,
     EENTRY = 267,
     MENUBAR = 268,
     EMENUBAR = 269,
     MENU = 270,
     EMENU = 271,
     MENUITEM = 272,
     EMENUITEM = 273,
     EDIT = 274,
     EEDIT = 275,
     TREE = 276,
     ETREE = 277,
     LABEL = 278,
     ELABEL = 279,
     ITEM = 280,
     EITEM = 281,
     BUTTON = 282,
     EBUTTON = 283,
     BUTTONOK = 284,
     BUTTONCANCEL = 285,
     BUTTONHELP = 286,
     BUTTONYES = 287,
     BUTTONNO = 288,
     CHECKBOX = 289,
     ECHECKBOX = 290,
     RADIO = 291,
     ERADIO = 292,
     LIST = 293,
     ELIST = 294,
     TABLE = 295,
     ETABLE = 296,
     COMBO = 297,
     ECOMBO = 298,
     GVIM = 299,
     EGVIM = 300,
     TEXT = 301,
     ETEXT = 302,
     PIXMAP = 303,
     EPIXMAP = 304,
     DEFAULT = 305,
     EDEFAULT = 306,
     VISIBLE = 307,
     EVISIBLE = 308,
     VARIABLE = 309,
     EVARIABLE = 310,
     WIDTH = 311,
     EWIDTH = 312,
     HEIGHT = 313,
     EHEIGHT = 314,
     INPUT = 315,
     INPUTFILE = 316,
     EINPUT = 317,
     OUTPUT = 318,
     OUTPUTFILE = 319,
     EOUTPUT = 320,
     ACTION = 321,
     EACTION = 322,
     ACTIONCLEAR = 323,
     ACTIONFILESEL = 324,
     ACTIONREMOVE = 325,
     ACTIONREFRESH = 326,
     ACTIONAPPEND = 327,
     ACTIONLAUNCH = 328,
     WTITLE = 329,
     EWTITLE = 330,
     NUMBER = 331,
     UMINUS = 332,
     STRING = 333
   };
#endif
/* Tokens.  */
#define BEGINTITLE 258
#define ENDTITLE 259
#define VBOX 260
#define EVBOX 261
#define HBOX 262
#define EHBOX 263
#define FRAME 264
#define EFRAME 265
#define ENTRY 266
#define EENTRY 267
#define MENUBAR 268
#define EMENUBAR 269
#define MENU 270
#define EMENU 271
#define MENUITEM 272
#define EMENUITEM 273
#define EDIT 274
#define EEDIT 275
#define TREE 276
#define ETREE 277
#define LABEL 278
#define ELABEL 279
#define ITEM 280
#define EITEM 281
#define BUTTON 282
#define EBUTTON 283
#define BUTTONOK 284
#define BUTTONCANCEL 285
#define BUTTONHELP 286
#define BUTTONYES 287
#define BUTTONNO 288
#define CHECKBOX 289
#define ECHECKBOX 290
#define RADIO 291
#define ERADIO 292
#define LIST 293
#define ELIST 294
#define TABLE 295
#define ETABLE 296
#define COMBO 297
#define ECOMBO 298
#define GVIM 299
#define EGVIM 300
#define TEXT 301
#define ETEXT 302
#define PIXMAP 303
#define EPIXMAP 304
#define DEFAULT 305
#define EDEFAULT 306
#define VISIBLE 307
#define EVISIBLE 308
#define VARIABLE 309
#define EVARIABLE 310
#define WIDTH 311
#define EWIDTH 312
#define HEIGHT 313
#define EHEIGHT 314
#define INPUT 315
#define INPUTFILE 316
#define EINPUT 317
#define OUTPUT 318
#define OUTPUTFILE 319
#define EOUTPUT 320
#define ACTION 321
#define EACTION 322
#define ACTIONCLEAR 323
#define ACTIONFILESEL 324
#define ACTIONREMOVE 325
#define ACTIONREFRESH 326
#define ACTIONAPPEND 327
#define ACTIONLAUNCH 328
#define WTITLE 329
#define EWTITLE 330
#define NUMBER 331
#define UMINUS 332
#define STRING 333




/* Copy the first part of user declarations.  */
#line 1 "parser.y"

/*
** parser.y: A simple grammar for the XML-like language we use.
** copyright: (c) 2003 by László Pere
** email: pipas@linux.pte.hu
**
** This program is free software; you can redistribute it and/or 
** modify  it under the terms of the GNU General Public License as
** published by the Free Software Foundation; either version 2 of
** the License, or (at your option) any later version.
**
** $Id: parser.y,v 1.1 2004/11/19 22:10:08 pipas Exp pipas $
** $Log: parser.y,v $
** Revision 1.1  2004/11/19 22:10:08  pipas
** Initial revision
**
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "automaton.h"

int linenumber = 1;
extern char *Token;

//
// Function declarations
//
int yywarning(char *c);



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 32 "parser.y"
{ 
  double  dval;
  char    *cval;
}
/* Line 187 of yacc.c.  */
#line 289 "y.tab.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 302 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  63
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   929

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  83
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  35
/* YYNRULES -- Number of rules.  */
#define YYNRULES  86
/* YYNRULES -- Number of states.  */
#define YYNSTATES  177

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   333

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    79,    78,     2,    77,     2,    80,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    81,    82
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    12,    16,    20,    22,    24,
      26,    28,    30,    32,    34,    36,    38,    40,    42,    44,
      46,    50,    54,    58,    62,    66,    70,    74,    78,    82,
      86,    90,    94,    98,   102,   106,   110,   114,   118,   122,
     126,   130,   134,   137,   141,   144,   149,   153,   159,   163,
     168,   172,   175,   176,   179,   182,   185,   188,   191,   194,
     197,   200,   203,   206,   210,   214,   218,   222,   226,   230,
     234,   238,   242,   246,   250,   252,   254,   256,   258,   260,
     262,   266,   270,   274,   278,   282,   286
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      84,     0,    -1,    85,    -1,    84,    84,    -1,     5,    84,
       6,    -1,     7,    84,     8,    -1,     9,    84,    10,    -1,
      89,    -1,    86,    -1,    87,    -1,    88,    -1,    90,    -1,
      91,    -1,    92,    -1,    93,    -1,    94,    -1,    95,    -1,
      96,    -1,    97,    -1,   100,    -1,    11,   101,    12,    -1,
      11,   101,    11,    -1,    19,   101,    20,    -1,    19,   101,
      19,    -1,    21,   101,    22,    -1,    21,   101,    21,    -1,
      46,   101,    47,    -1,    46,   101,    46,    -1,    27,   101,
      28,    -1,    29,   101,    28,    -1,    30,   101,    28,    -1,
      31,   101,    28,    -1,    33,   101,    28,    -1,    32,   101,
      28,    -1,    34,   101,    35,    -1,    34,   101,    34,    -1,
      36,   101,    37,    -1,    38,   101,    39,    -1,    40,   101,
      41,    -1,    42,   101,    43,    -1,    44,   101,    45,    -1,
      48,   101,    49,    -1,    13,    14,    -1,    13,    98,    14,
      -1,    15,    16,    -1,    15,    99,   101,    16,    -1,    98,
      15,    16,    -1,    98,    15,    99,   101,    16,    -1,    17,
     101,    18,    -1,    99,    17,   101,    18,    -1,    74,    82,
      75,    -1,    74,    75,    -1,    -1,   101,   105,    -1,   101,
     104,    -1,   101,   103,    -1,   101,   102,    -1,   101,   106,
      -1,   101,   107,    -1,   101,   108,    -1,   101,   109,    -1,
     101,   110,    -1,   101,   117,    -1,    23,    82,    24,    -1,
      54,    82,    55,    -1,    52,    82,    53,    -1,    50,    82,
      51,    -1,    56,    82,    57,    -1,    58,    82,    59,    -1,
      60,    82,    62,    -1,    61,    82,    62,    -1,    63,    82,
      65,    -1,    64,    82,    65,    -1,    66,    82,    67,    -1,
     111,    -1,   112,    -1,   114,    -1,   113,    -1,   115,    -1,
     116,    -1,    68,    82,    67,    -1,    72,    82,    67,    -1,
      70,    82,    67,    -1,    69,    82,    67,    -1,    71,    82,
      67,    -1,    73,    82,    67,    -1,    25,    82,    26,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint8 yyrline[] =
{
       0,    81,    81,    82,    83,    84,    85,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     106,   107,   111,   112,   115,   116,   119,   120,   122,   123,
     124,   125,   126,   127,   129,   130,   134,   136,   138,   140,
     143,   146,   149,   150,   153,   154,   155,   156,   161,   162,
     168,   169,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   185,   188,   191,   194,   197,   200,   203,
     205,   209,   211,   214,   216,   217,   218,   219,   220,   221,
     224,   228,   232,   236,   240,   244,   248
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "BEGINTITLE", "ENDTITLE", "VBOX",
  "EVBOX", "HBOX", "EHBOX", "FRAME", "EFRAME", "ENTRY", "EENTRY",
  "MENUBAR", "EMENUBAR", "MENU", "EMENU", "MENUITEM", "EMENUITEM", "EDIT",
  "EEDIT", "TREE", "ETREE", "LABEL", "ELABEL", "ITEM", "EITEM", "BUTTON",
  "EBUTTON", "BUTTONOK", "BUTTONCANCEL", "BUTTONHELP", "BUTTONYES",
  "BUTTONNO", "CHECKBOX", "ECHECKBOX", "RADIO", "ERADIO", "LIST", "ELIST",
  "TABLE", "ETABLE", "COMBO", "ECOMBO", "GVIM", "EGVIM", "TEXT", "ETEXT",
  "PIXMAP", "EPIXMAP", "DEFAULT", "EDEFAULT", "VISIBLE", "EVISIBLE",
  "VARIABLE", "EVARIABLE", "WIDTH", "EWIDTH", "HEIGHT", "EHEIGHT", "INPUT",
  "INPUTFILE", "EINPUT", "OUTPUT", "OUTPUTFILE", "EOUTPUT", "ACTION",
  "EACTION", "ACTIONCLEAR", "ACTIONFILESEL", "ACTIONREMOVE",
  "ACTIONREFRESH", "ACTIONAPPEND", "ACTIONLAUNCH", "WTITLE", "EWTITLE",
  "NUMBER", "'-'", "'+'", "'*'", "'/'", "UMINUS", "STRING", "$accept",
  "wlist", "widget", "entry", "edit", "tree", "text", "button", "checkbox",
  "radiobutton", "list", "table", "combo", "gvim", "menubar", "menus",
  "menuitems", "window", "attr", "label", "variable", "visible",
  "defaultvalue", "width", "height", "input", "output", "action",
  "actionclear", "actionappend", "actionremove", "actionfilesel",
  "actionrefresh", "actionlaunch", "item", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    45,    43,    42,
      47,   332,   333
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    83,    84,    84,    84,    84,    84,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      86,    86,    87,    87,    88,    88,    89,    89,    90,    90,
      90,    90,    90,    90,    91,    91,    92,    93,    94,    95,
      96,    95,    97,    97,    98,    98,    98,    98,    99,    99,
     100,   100,   101,   101,   101,   101,   101,   101,   101,   101,
     101,   101,   101,   102,   103,   104,   105,   106,   107,   108,
     108,   109,   109,   110,   110,   110,   110,   110,   110,   110,
     111,   112,   113,   114,   115,   116,   117
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     3,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     2,     4,     3,     5,     3,     4,
       3,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,    52,     0,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,     0,     0,     2,     8,     9,    10,     7,    11,
      12,    13,    14,    15,    16,    17,    18,    19,     0,     0,
       0,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    51,     0,     1,     3,     4,     5,     6,    21,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    56,    55,
      54,    53,    57,    58,    59,    60,    61,    74,    75,    77,
      76,    78,    79,    62,    44,    52,    52,    43,     0,    23,
      22,    25,    24,    28,    29,    30,    31,    33,    32,    35,
      34,    36,    37,    38,    39,    40,    27,    26,    41,    50,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    52,
       0,    46,    52,    63,    86,    66,    65,    64,    67,    68,
      69,    70,    71,    72,    73,    80,    83,    82,    84,    81,
      85,    48,     0,    45,     0,    49,    47
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    64,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    44,   106,    37,    41,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -61
static const yytype_int16 yypact[] =
{
     212,   212,   212,   212,   -61,     4,   -61,   -61,   -61,   -61,
     -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,
     -61,   -61,   -58,    16,   -61,   -61,   -61,   -61,   -61,   -61,
     -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,    74,   120,
     166,   224,   -61,    25,    77,   403,   456,   518,   552,   586,
     620,   654,   688,     5,   716,   742,   768,   800,   830,   484,
     856,   -61,   -55,   -61,   212,   -61,   -61,   -61,   -61,   -61,
     -60,   -56,   -46,   -44,   -38,   -31,   -29,   -15,   -12,   -10,
       0,     2,    12,    14,    15,    20,    27,    29,   -61,   -61,
     -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,
     -61,   -61,   -61,   -61,   -61,   -61,    69,   -61,    72,   -61,
     -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,
     -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,
      89,    91,    47,    62,    64,    66,    65,    59,    68,    61,
      67,    70,    71,    73,    75,    78,    88,    90,   323,   -61,
     248,   -61,    69,   -61,   -61,   -61,   -61,   -61,   -61,   -61,
     -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,
     -61,   -61,   379,   -61,   299,   -61,   -61
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -61,    31,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,
     -61,   -61,   -61,   -61,   -61,   -61,    26,   -61,    -6,   -61,
     -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,
     -61,   -61,   -61,   -61,   -61
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    63,    61,    42,    43,
     129,     1,   130,     2,    62,     3,   131,     4,    70,     5,
      71,    23,    38,    39,    40,     6,   132,     7,   133,   119,
     120,   104,   105,     8,   134,     9,    10,    11,    12,    13,
      14,   135,    15,   136,    16,    72,    17,    73,    18,    74,
      19,    75,    20,    76,    21,    77,    78,   137,    79,    80,
     138,    81,   139,    82,    83,    84,    85,    86,    87,     1,
      65,     2,   140,     3,   141,     4,   149,     5,   151,   105,
      22,   107,   108,     6,   142,     7,   143,   144,   155,   148,
     150,     8,   145,     9,    10,    11,    12,    13,    14,   146,
      15,   147,    16,   153,    17,   156,    18,   154,    19,   157,
      20,   160,    21,   158,   159,     1,   162,     2,    66,     3,
     161,     4,   163,     5,   152,     0,     0,   164,   165,     6,
     166,     7,   167,   172,     0,   168,   174,     8,    22,     9,
      10,    11,    12,    13,    14,   169,    15,   170,    16,     0,
      17,     0,    18,     0,    19,     0,    20,     0,    21,     0,
       0,     1,     0,     2,     0,     3,    67,     4,     0,     5,
       0,     0,     0,     0,     0,     6,     0,     7,     0,     0,
       0,     0,     0,     8,    22,     9,    10,    11,    12,    13,
      14,     0,    15,     0,    16,     0,    17,     0,    18,     0,
      19,     0,    20,     0,    21,     0,     0,     1,     0,     2,
       0,     3,     0,     4,     0,     5,     0,     0,     0,     0,
       0,     6,     0,     7,     0,    68,    69,     0,     0,     8,
      22,     9,    10,    11,    12,    13,    14,    70,    15,    71,
      16,     0,    17,     0,    18,     0,    19,     0,    20,     0,
      21,     0,     0,     0,   173,     0,     0,     0,     0,     0,
       0,    70,     0,    71,    72,     0,    73,     0,    74,     0,
      75,     0,    76,     0,    77,    78,    22,    79,    80,     0,
      81,     0,    82,    83,    84,    85,    86,    87,    72,     0,
      73,     0,    74,     0,    75,     0,    76,     0,    77,    78,
       0,    79,    80,     0,    81,   176,    82,    83,    84,    85,
      86,    87,    70,     0,    71,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   171,     0,     0,     0,     0,    70,     0,    71,    72,
       0,    73,     0,    74,     0,    75,     0,    76,     0,    77,
      78,     0,    79,    80,     0,    81,     0,    82,    83,    84,
      85,    86,    87,    72,     0,    73,     0,    74,     0,    75,
       0,    76,     0,    77,    78,     0,    79,    80,     0,    81,
       0,    82,    83,    84,    85,    86,    87,   175,     0,     0,
       0,     0,    70,     0,    71,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   109,   110,     0,     0,    70,     0,    71,    72,
       0,    73,     0,    74,     0,    75,     0,    76,     0,    77,
      78,     0,    79,    80,     0,    81,     0,    82,    83,    84,
      85,    86,    87,    72,     0,    73,     0,    74,     0,    75,
       0,    76,     0,    77,    78,     0,    79,    80,     0,    81,
       0,    82,    83,    84,    85,    86,    87,   111,   112,    70,
       0,    71,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    72,    70,    73,    71,
      74,     0,    75,     0,    76,     0,    77,    78,     0,    79,
      80,     0,    81,     0,    82,    83,    84,    85,    86,    87,
     126,   127,     0,     0,    72,     0,    73,     0,    74,     0,
      75,    70,    76,    71,    77,    78,   113,    79,    80,     0,
      81,     0,    82,    83,    84,    85,    86,    87,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    72,     0,
      73,     0,    74,     0,    75,    70,    76,    71,    77,    78,
     114,    79,    80,     0,    81,     0,    82,    83,    84,    85,
      86,    87,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    72,     0,    73,     0,    74,     0,    75,    70,
      76,    71,    77,    78,   115,    79,    80,     0,    81,     0,
      82,    83,    84,    85,    86,    87,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    72,     0,    73,     0,
      74,     0,    75,    70,    76,    71,    77,    78,   116,    79,
      80,     0,    81,     0,    82,    83,    84,    85,    86,    87,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      72,     0,    73,     0,    74,     0,    75,    70,    76,    71,
      77,    78,   117,    79,    80,     0,    81,     0,    82,    83,
      84,    85,    86,    87,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    72,     0,    73,     0,    74,     0,
      75,    70,    76,    71,    77,    78,   118,    79,    80,     0,
      81,     0,    82,    83,    84,    85,    86,    87,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    72,    70,
      73,    71,    74,     0,    75,     0,    76,     0,    77,    78,
       0,    79,    80,   121,    81,     0,    82,    83,    84,    85,
      86,    87,     0,     0,     0,    70,    72,    71,    73,     0,
      74,     0,    75,     0,    76,     0,    77,    78,     0,    79,
      80,   122,    81,     0,    82,    83,    84,    85,    86,    87,
       0,    70,    72,    71,    73,     0,    74,     0,    75,     0,
      76,     0,    77,    78,     0,    79,    80,     0,    81,   123,
      82,    83,    84,    85,    86,    87,     0,     0,    72,     0,
      73,     0,    74,    70,    75,    71,    76,     0,    77,    78,
       0,    79,    80,     0,    81,     0,    82,    83,    84,    85,
      86,    87,     0,   124,     0,     0,     0,     0,     0,     0,
      72,     0,    73,    70,    74,    71,    75,     0,    76,     0,
      77,    78,     0,    79,    80,     0,    81,     0,    82,    83,
      84,    85,    86,    87,     0,   125,     0,     0,     0,    70,
      72,    71,    73,     0,    74,     0,    75,     0,    76,     0,
      77,    78,     0,    79,    80,     0,    81,     0,    82,    83,
      84,    85,    86,    87,     0,   128,    72,     0,    73,     0,
      74,     0,    75,     0,    76,     0,    77,    78,     0,    79,
      80,     0,    81,     0,    82,    83,    84,    85,    86,    87
};

static const yytype_int16 yycheck[] =
{
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,     0,    75,    14,    15,
      75,     5,    82,     7,    82,     9,    82,    11,    23,    13,
      25,     0,     1,     2,     3,    19,    82,    21,    82,    34,
      35,    16,    17,    27,    82,    29,    30,    31,    32,    33,
      34,    82,    36,    82,    38,    50,    40,    52,    42,    54,
      44,    56,    46,    58,    48,    60,    61,    82,    63,    64,
      82,    66,    82,    68,    69,    70,    71,    72,    73,     5,
       6,     7,    82,     9,    82,    11,    17,    13,    16,    17,
      74,    14,    15,    19,    82,    21,    82,    82,    51,   105,
     106,    27,    82,    29,    30,    31,    32,    33,    34,    82,
      36,    82,    38,    24,    40,    53,    42,    26,    44,    55,
      46,    62,    48,    57,    59,     5,    65,     7,     8,     9,
      62,    11,    65,    13,   108,    -1,    -1,    67,    67,    19,
      67,    21,    67,   149,    -1,    67,   152,    27,    74,    29,
      30,    31,    32,    33,    34,    67,    36,    67,    38,    -1,
      40,    -1,    42,    -1,    44,    -1,    46,    -1,    48,    -1,
      -1,     5,    -1,     7,    -1,     9,    10,    11,    -1,    13,
      -1,    -1,    -1,    -1,    -1,    19,    -1,    21,    -1,    -1,
      -1,    -1,    -1,    27,    74,    29,    30,    31,    32,    33,
      34,    -1,    36,    -1,    38,    -1,    40,    -1,    42,    -1,
      44,    -1,    46,    -1,    48,    -1,    -1,     5,    -1,     7,
      -1,     9,    -1,    11,    -1,    13,    -1,    -1,    -1,    -1,
      -1,    19,    -1,    21,    -1,    11,    12,    -1,    -1,    27,
      74,    29,    30,    31,    32,    33,    34,    23,    36,    25,
      38,    -1,    40,    -1,    42,    -1,    44,    -1,    46,    -1,
      48,    -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    -1,    25,    50,    -1,    52,    -1,    54,    -1,
      56,    -1,    58,    -1,    60,    61,    74,    63,    64,    -1,
      66,    -1,    68,    69,    70,    71,    72,    73,    50,    -1,
      52,    -1,    54,    -1,    56,    -1,    58,    -1,    60,    61,
      -1,    63,    64,    -1,    66,    16,    68,    69,    70,    71,
      72,    73,    23,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    -1,    -1,    -1,    -1,    23,    -1,    25,    50,
      -1,    52,    -1,    54,    -1,    56,    -1,    58,    -1,    60,
      61,    -1,    63,    64,    -1,    66,    -1,    68,    69,    70,
      71,    72,    73,    50,    -1,    52,    -1,    54,    -1,    56,
      -1,    58,    -1,    60,    61,    -1,    63,    64,    -1,    66,
      -1,    68,    69,    70,    71,    72,    73,    18,    -1,    -1,
      -1,    -1,    23,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    -1,    -1,    23,    -1,    25,    50,
      -1,    52,    -1,    54,    -1,    56,    -1,    58,    -1,    60,
      61,    -1,    63,    64,    -1,    66,    -1,    68,    69,    70,
      71,    72,    73,    50,    -1,    52,    -1,    54,    -1,    56,
      -1,    58,    -1,    60,    61,    -1,    63,    64,    -1,    66,
      -1,    68,    69,    70,    71,    72,    73,    21,    22,    23,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    50,    23,    52,    25,
      54,    -1,    56,    -1,    58,    -1,    60,    61,    -1,    63,
      64,    -1,    66,    -1,    68,    69,    70,    71,    72,    73,
      46,    47,    -1,    -1,    50,    -1,    52,    -1,    54,    -1,
      56,    23,    58,    25,    60,    61,    28,    63,    64,    -1,
      66,    -1,    68,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      52,    -1,    54,    -1,    56,    23,    58,    25,    60,    61,
      28,    63,    64,    -1,    66,    -1,    68,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    -1,    52,    -1,    54,    -1,    56,    23,
      58,    25,    60,    61,    28,    63,    64,    -1,    66,    -1,
      68,    69,    70,    71,    72,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    52,    -1,
      54,    -1,    56,    23,    58,    25,    60,    61,    28,    63,
      64,    -1,    66,    -1,    68,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      50,    -1,    52,    -1,    54,    -1,    56,    23,    58,    25,
      60,    61,    28,    63,    64,    -1,    66,    -1,    68,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    52,    -1,    54,    -1,
      56,    23,    58,    25,    60,    61,    28,    63,    64,    -1,
      66,    -1,    68,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    23,
      52,    25,    54,    -1,    56,    -1,    58,    -1,    60,    61,
      -1,    63,    64,    37,    66,    -1,    68,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    23,    50,    25,    52,    -1,
      54,    -1,    56,    -1,    58,    -1,    60,    61,    -1,    63,
      64,    39,    66,    -1,    68,    69,    70,    71,    72,    73,
      -1,    23,    50,    25,    52,    -1,    54,    -1,    56,    -1,
      58,    -1,    60,    61,    -1,    63,    64,    -1,    66,    41,
      68,    69,    70,    71,    72,    73,    -1,    -1,    50,    -1,
      52,    -1,    54,    23,    56,    25,    58,    -1,    60,    61,
      -1,    63,    64,    -1,    66,    -1,    68,    69,    70,    71,
      72,    73,    -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,
      50,    -1,    52,    23,    54,    25,    56,    -1,    58,    -1,
      60,    61,    -1,    63,    64,    -1,    66,    -1,    68,    69,
      70,    71,    72,    73,    -1,    45,    -1,    -1,    -1,    23,
      50,    25,    52,    -1,    54,    -1,    56,    -1,    58,    -1,
      60,    61,    -1,    63,    64,    -1,    66,    -1,    68,    69,
      70,    71,    72,    73,    -1,    49,    50,    -1,    52,    -1,
      54,    -1,    56,    -1,    58,    -1,    60,    61,    -1,    63,
      64,    -1,    66,    -1,    68,    69,    70,    71,    72,    73
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     5,     7,     9,    11,    13,    19,    21,    27,    29,
      30,    31,    32,    33,    34,    36,    38,    40,    42,    44,
      46,    48,    74,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,   100,    84,    84,
      84,   101,    14,    15,    98,   101,   101,   101,   101,   101,
     101,   101,   101,   101,   101,   101,   101,   101,   101,   101,
     101,    75,    82,     0,    84,     6,     8,    10,    11,    12,
      23,    25,    50,    52,    54,    56,    58,    60,    61,    63,
      64,    66,    68,    69,    70,    71,    72,    73,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    16,    17,    99,    14,    15,    19,
      20,    21,    22,    28,    28,    28,    28,    28,    28,    34,
      35,    37,    39,    41,    43,    45,    46,    47,    49,    75,
      82,    82,    82,    82,    82,    82,    82,    82,    82,    82,
      82,    82,    82,    82,    82,    82,    82,    82,   101,    17,
     101,    16,    99,    24,    26,    51,    53,    55,    57,    59,
      62,    62,    65,    65,    67,    67,    67,    67,    67,    67,
      67,    18,   101,    16,   101,    18,    16
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 82 "parser.y"
    { token_store(SUM);                }
    break;

  case 4:
#line 83 "parser.y"
    { token_store(PUSH | WIDGET_VBOX); }
    break;

  case 5:
#line 84 "parser.y"
    { token_store(PUSH | WIDGET_HBOX); }
    break;

  case 6:
#line 85 "parser.y"
    { 
                         token_store_with_argument(SET|ATTR_LABEL, (yyvsp[(1) - (3)].cval)); 
                         token_store(PUSH | WIDGET_FRAME);
		       }
    break;

  case 20:
#line 106 "parser.y"
    {token_store(PUSH | WIDGET_ENTRY); }
    break;

  case 21:
#line 107 "parser.y"
    {
                  yyerror("</entry> expected instead of <entry>.");}
    break;

  case 22:
#line 111 "parser.y"
    {token_store(PUSH | WIDGET_EDIT); }
    break;

  case 23:
#line 112 "parser.y"
    {yyerror("</edit> expected instead of <edit>.");}
    break;

  case 24:
#line 115 "parser.y"
    {token_store(PUSH | WIDGET_TREE); }
    break;

  case 25:
#line 116 "parser.y"
    {yyerror("</tree> expected instead of <tree>.");}
    break;

  case 26:
#line 119 "parser.y"
    {token_store(PUSH | WIDGET_LABEL); }
    break;

  case 27:
#line 120 "parser.y"
    {yyerror("</text> expected instead of <text>.");}
    break;

  case 28:
#line 122 "parser.y"
    {token_store(PUSH | WIDGET_BUTTON);  }
    break;

  case 29:
#line 123 "parser.y"
    {token_store(PUSH | WIDGET_OKBUTTON);}
    break;

  case 30:
#line 124 "parser.y"
    {token_store(PUSH | WIDGET_CANCELBUTTON);}
    break;

  case 31:
#line 125 "parser.y"
    {token_store(PUSH | WIDGET_HELPBUTTON);}
    break;

  case 32:
#line 126 "parser.y"
    {token_store(PUSH | WIDGET_NOBUTTON);}
    break;

  case 33:
#line 127 "parser.y"
    {token_store(PUSH | WIDGET_YESBUTTON);}
    break;

  case 34:
#line 129 "parser.y"
    {token_store(PUSH | WIDGET_CHECKBOX);}
    break;

  case 35:
#line 130 "parser.y"
    {
           yyerror("</checkbox> expected instead of <checkbox>.");  }
    break;

  case 36:
#line 134 "parser.y"
    {token_store(PUSH | WIDGET_RADIO);}
    break;

  case 37:
#line 136 "parser.y"
    {token_store(PUSH | WIDGET_LIST); }
    break;

  case 38:
#line 138 "parser.y"
    {token_store(PUSH | WIDGET_TABLE);}
    break;

  case 39:
#line 140 "parser.y"
    {token_store(PUSH | WIDGET_COMBO);}
    break;

  case 40:
#line 143 "parser.y"
    {token_store(PUSH | WIDGET_GVIM);}
    break;

  case 41:
#line 146 "parser.y"
    {token_store(PUSH | WIDGET_PIXMAP);}
    break;

  case 42:
#line 149 "parser.y"
    {yyerror("Empty menubar without a single <menu> tag.");}
    break;

  case 43:
#line 150 "parser.y"
    {token_store(PUSH | WIDGET_MENUBAR);}
    break;

  case 44:
#line 153 "parser.y"
    { yyerror("Empty menu without <menuitem> tag.");}
    break;

  case 45:
#line 154 "parser.y"
    { token_store(PUSH | WIDGET_MENU);   }
    break;

  case 46:
#line 155 "parser.y"
    { yyerror("Empty menu without <menuitem> tag.");}
    break;

  case 47:
#line 156 "parser.y"
    { token_store(PUSH | WIDGET_MENU);   
                                    token_store(SUM);
                                  }
    break;

  case 48:
#line 161 "parser.y"
    {token_store(PUSH | WIDGET_MENUITEM); }
    break;

  case 49:
#line 162 "parser.y"
    {
	                                       token_store(PUSH | WIDGET_MENUITEM); 
					       token_store(SUM);
	                                     }
    break;

  case 50:
#line 168 "parser.y"
    {window_title((yyvsp[(2) - (3)].cval));}
    break;

  case 51:
#line 169 "parser.y"
    {window_title("MAIN_DIALOG");}
    break;

  case 63:
#line 185 "parser.y"
    {
     token_store_with_argument( SET | ATTR_LABEL, (yyvsp[(2) - (3)].cval));     }
    break;

  case 64:
#line 188 "parser.y"
    {
     token_store_with_argument( SET | ATTR_VARIABLE, (yyvsp[(2) - (3)].cval)); }
    break;

  case 65:
#line 191 "parser.y"
    {
     token_store_with_argument( SET | ATTR_VISIBLE, (yyvsp[(2) - (3)].cval));  }
    break;

  case 66:
#line 194 "parser.y"
    {
     token_store_with_argument( SET | ATTR_DEFAULT, (yyvsp[(2) - (3)].cval));   }
    break;

  case 67:
#line 197 "parser.y"
    {
     token_store_with_argument( SET | ATTR_WIDTH, (yyvsp[(2) - (3)].cval));    }
    break;

  case 68:
#line 200 "parser.y"
    {
     token_store_with_argument( SET | ATTR_HEIGHT, (yyvsp[(2) - (3)].cval));   }
    break;

  case 69:
#line 203 "parser.y"
    { 
       token_store_with_argument(SET|ATTR_INPUT|SUB_ATTR_SHELL,(yyvsp[(2) - (3)].cval));}
    break;

  case 70:
#line 205 "parser.y"
    { 
       token_store_with_argument(SET|ATTR_INPUT|SUB_ATTR_FILE,(yyvsp[(2) - (3)].cval)); }
    break;

  case 71:
#line 209 "parser.y"
    {
         fprintf( stderr, "<output>: Not implemented.\n" ); }
    break;

  case 72:
#line 211 "parser.y"
    {
         token_store_with_argument(SET|ATTR_OUTPUT|SUB_ATTR_FILE,(yyvsp[(2) - (3)].cval));}
    break;

  case 73:
#line 214 "parser.y"
    { 
       token_store_with_argument( SET|ATTR_ACTION, (yyvsp[(2) - (3)].cval));    }
    break;

  case 80:
#line 224 "parser.y"
    { 
  token_store_with_argument( SET|ATTR_ACTION|SUB_ATTR_CLEAR, (yyvsp[(2) - (3)].cval));}
    break;

  case 81:
#line 228 "parser.y"
    { 
  token_store_with_argument( SET|ATTR_ACTION|SUB_ATTR_APPEND, (yyvsp[(2) - (3)].cval));}
    break;

  case 82:
#line 232 "parser.y"
    { 
  token_store_with_argument( SET|ATTR_ACTION|SUB_ATTR_REMOVE, (yyvsp[(2) - (3)].cval));}
    break;

  case 83:
#line 236 "parser.y"
    { 
  token_store_with_argument( SET|ATTR_ACTION|SUB_ATTR_FILESEL, (yyvsp[(2) - (3)].cval));}
    break;

  case 84:
#line 240 "parser.y"
    { 
  token_store_with_argument( SET|ATTR_ACTION|SUB_ATTR_REFRESH, (yyvsp[(2) - (3)].cval));}
    break;

  case 85:
#line 244 "parser.y"
    { 
  token_store_with_argument( SET|ATTR_ACTION|SUB_ATTR_LAUNCH, (yyvsp[(2) - (3)].cval));}
    break;

  case 86:
#line 248 "parser.y"
    { 
       token_store_with_argument( SET | ATTR_ITEM, (yyvsp[(2) - (3)].cval));    }
    break;


/* Line 1267 of yacc.c.  */
#line 2113 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 252 "parser.y"


int yywrap(void)
{
	run_program();
	return (0);
}

int yyerror(char *c)
{
	printf("Error in line %d, near token '%s': %s\n", 
			linenumber, Token, c);
	exit(EXIT_FAILURE);
}

int yywarning(char *c){
	printf("Warning: %s\n", c);
	return 0;
}

