#ifndef MYSTACK_H
#define MYSTACK_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#define MAXWIDGETS 128;


/* The elements in stack can contain MAXWIDGETS number of widgets.
 *
 */
typedef struct stackelement {
  char       *cval;
  int         nwidgets;
  GtkWidget   *widgets[128];
  int         widgettypes[128];
} stackelement;

stackelement pop();
void push(stackelement a);
void push_widget(GtkWidget * widget, int widgettype); //GN

#endif

